$Maze::TickTime = "100";
datablock fxDTSBrickData(brickMazeTunnelC) 
{ 
	brickFile = "./TunnelL.blb"; 
	category = "Special"; 
	subCategory = "Maze Tunnels"; 
	uiName = "Tunnel L";
	isWaterBrick = true;
}; 
datablock fxDTSBrickData(brickMazeTunnelS) 
{ 
	brickFile = "./TunnelI.blb"; 
	category = "Special"; 
	subCategory = "Maze Tunnels"; 
	uiName = "Tunnel S";
	isWaterBrick = true;
}; 
datablock fxDTSBrickData(brickMazeTunnelEnd) 
{ 
	brickFile = "./TunnelEnd.blb"; 
	category = "Special"; 
	subCategory = "Maze Tunnels"; 
	uiName = "Tunnel End";
	isWaterBrick = true;
}; 
datablock fxDTSBrickData(brickMazeTunnelT) 
{ 
	brickFile = "./TunnelT.blb"; 
	category = "Special"; 
	subCategory = "Maze Tunnels"; 
	uiName = "Tunnel T";
	isWaterBrick = true;
}; 
datablock fxDTSBrickData(brickMazeTunnelX) 
{ 
	brickFile = "./TunnelX.blb"; 
	category = "Special"; 
	subCategory = "Maze Tunnels"; 
	uiName = "Tunnel X";
	isWaterBrick = true;
};

datablock fxDTSBrickData(brickMazeTunnelEndSpawn : brickSpawnPointData) 
{ 
	brickFile = "./TunnelEnd.blb"; 
	category = "Special"; 
	subCategory = "Maze Tunnels"; 
	uiName = "Tunnel End Spawn";
	isWaterBrick = true;
	cancover = 1;
};

function BrickRotationID(%ad)
{
   if(%ad==0)
      return "1 0 0 0";
   else if(%ad==1)
      return"0 0 1 90.0002";
   else if(%ad==2)
      return "0 0 1 180";
   else if(%ad==3)
      return "0 0 -1 90.0002";
   else
      return "1 0 0 0";
}
function replantMazeBrick(%tempbrick,%rot,%data)
{
   %tempbrick.setName("CopyBrick");
   %brick = new fxDTSBrick(:CopyBrick)
   {
      datablock = %data;
      isPlanted = true;
      mazebrick = true;
      rotation = BrickRotationID(%rot);
   };
   %sss = %tempbrick.mazeBrickCount;
   %tempbrick.delete();
   
   %brick.plant();
	%brick.setTrusted(true);
	MissionCleanup.add(%brick);
	if(!isObject(BrickGroup_14)) {
		new SimGroup(BrickGroup_14) {
			name = "Maze Generator";
			bl_id = 14;
		};
		MainBrickGroup.add(BrickGroup_14);
	}
	BrickGroup_14.add(%brick);
	$Maze::Brick[%sss] = %brick;
	return %brick;
	
}
function scanMazeBricks(%pos)
{
   %x = getWord(%pos,0);
   %y = getWord(%pos,1);
   %z = getWord(%pos,2);
   %string = "";
   if($Maze::isBrick[%x + 1 SPC %y SPC %z])
      %string = %string@"2";
   if($Maze::isBrick[%x - 1 SPC %y SPC %z])
      %string = %string@"1";
   if($Maze::isBrick[%x SPC %y + 1 SPC %z])
      %string = %string@"3";
   if($Maze::isBrick[%x SPC %y - 1 SPC %z])
      %string = %string@"4";
         //    [4]
         // [2][ ][1]
         //    [3]
         
   return %string;
}
function mazePickDataRot(%string)
{
   for(%i = 0; %i < 4; %i++)
      if(charamount(%string,%i+1))
      {
        %pos[%i+1] = 1;
        %count++;
      }
   if(%count==1)
   {
      %data = "brickMazeTunnelEnd";
      if(%pos[1])
         //    [ ]
         // [ ][X][X]
         //    [ ]
         %rot = 3;
      else if(%pos[2])
         //    [ ]
         // [X][X][ ]
         //    [ ]
         %rot = 1;
      else if(%pos[3])
         //    [ ]
         // [ ][X][ ]
         //    [X]
         %rot = 0;
      else
         //    [X]
         // [ ][X][ ]
         //    [ ]
         %rot = 2;
   }
   else if(%count==2)
   {
      if(%pos[1]&&%pos[2]) //Handle S1
      {
         //    [ ]
         // [X][X][X]
         //    [ ]
         
         %data = "brickMazeTunnelS";
         %rot = 1;
      }
      else if(%pos[2]&&%pos[3]) //Handle C1
      {
         //    [ ]
         // [X][X][ ]
         //    [X]
         %data = "brickMazeTunnelC";
         %rot = 3;
      }
      else if(%pos[3]&&%pos[4]) //Handle S2
      {
         //    [X]
         // [ ][X][ ]
         //    [X]
         %data = "brickMazeTunnelS";
         %rot = 0;
      }      
      else if(%pos[4]&&%pos[1]) //Handle C2
      {
         //    [X]
         // [ ][X][X]
         //    [ ]
         %data = "brickMazeTunnelC";
         %rot = 1;
      }
      else if(%pos[1]&&%pos[3]) //Handle C3
      {
         //    [ ]
         // [ ][X][X]
         //    [X]
         %data = "brickMazeTunnelC";
         %rot = 2;
      }
      else if(%pos[2]&&%pos[4]) //Handle C4
      {
         //    [X]
         // [X][X][ ]
         //    [ ]
         %data = "brickMazeTunnelC";
         %rot = 0;
      }
   }
   else if(%count==3)
   {
      %data = "brickMazeTunnelT";
      if(!%pos[1])
         //    [X]
         // [X][X][ ]
         //    [X]
         %rot = 1;
      else if(!%pos[2])
         //    [X]
         // [ ][X][X]
         //    [X]
         %rot = 3;
      else if(!%pos[3])
         //    [X]
         // [X][X][X]
         //    [ ]
         %rot = 2;
      else
         //    [ ]
         // [X][X][X]
         //    [X]
         %rot = 0;
   }
   else if(%count == 4)
   {
      %data = "brickMazeTunnelX";
         //    [X]
         // [X][ ][X]
         //    [X]
      %rot = 0;
   }
   else
   {
      %data = brick8xCubedata;
      %rot = -1;
   }
   $Maze::BrickDir[$Maze::BrickCount] = %rot;
   return %data SPC %rot;
}
function createMazeBrick(%pos,%data,%rot) {
   if($Maze::BrickCount == 4)
   {
      %col = 0;
      if($Maze::GenerateSpawns == 1)
         createMazeSpawnBrick(%pos,%rot);
   }
   else
      %col = $Maze::Color1;
   %brick = new fxDTSBrick() {
		position = getWord(%pos,0)*4 SPC getword(%pos,1)*4 SPC getWord(%pos,2)*4;
		datablock = %data;
		rotation = BrickRotationID(%rot);
		isPlanted = true;
		mazeBrick = true;
		mazebrickCount = $Maze::BrickCount;
		colorId = %col;
		colorFxId = 0;
	   client = localClientConnection;
	};
	%brick.plant();
	%brick.setTrusted(true);
	MissionCleanup.add(%brick);
	if(!isObject(BrickGroup_14)) {
		new SimGroup(BrickGroup_14) {
			name = "Maze Generator";
			bl_id = 14;
		};
		MainBrickGroup.add(BrickGroup_14);
	}
	BrickGroup_14.add(%brick);
	$Maze::isBrick[%pos] = true;
	$Maze::BrickPos[$Maze::BrickCount] = %pos;
	return %brick;
}
function findclosestcolor(%x) //input four numbers between 0 and 1
{
	for(%a=0; %a<64; %a++)
	{
		%match = mabs(getword(getcoloridtable(%a),0) - getword(%x,0)) + mabs(getword(getcoloridtable(%a),1) - getword(%x,1)) + mabs(getword(getcoloridtable(%a),2) - getword(%x,2)) + mabs(getword(getcoloridtable(%a),3) - getword(%x,3))*4;

		if(%match < %bestmatch || %bestmatch $= "")
		{
			%bestmatch = %match;
			%bestid = %a;
		}
	}
	return %bestid; //trans may be messed up if you input a nearly-but-not-quite opaque color
}
function createMazeChestBrick(%pos) {
   %brick = new fxDTSBrick() {
		position = getWord(%pos,0)*4 SPC getword(%pos,1)*4 SPC getWord(%pos,2)*4 - 1.4;
		datablock = brickTreasureChestData;
		rotation = BrickRotationID(getRandom(0,3));
		isPlanted = true;
		colorId = findclosestcolor(100/255.0 SPC 49/255.0 SPC 0 SPC 1);
		colorFxId = 0;
	   client = localClientConnection;
	};
	%brick.plant();
	%brick.setTrusted(true);
	%brick.setColliding(0);
	MissionCleanup.add(%brick);
	if(!isObject(BrickGroup_14)) {
		new SimGroup(BrickGroup_14) {
			name = "Maze Generator";
			bl_id = 14;
		};
		MainBrickGroup.add(BrickGroup_14);
	}
	BrickGroup_14.add(%brick);
	registerTreasureChest(%brick);   

   //add default events
   %enabled     = 1;
   %delay       = 0;
   %inputEvent  = "OnActivate";
   %target      = "Client";
   %outputEvent = "PlaySound";
   %par1        = rewardSound.getId();
   %brick.addEvent(%enabled, %delay, %inputEvent, %target, %outputEvent, %par1);
   
	return %brick;
}
function createMazeSpawnBrick(%pos,%rot) {
   if(!%rot)
      %rot = BrickRotationID(getRandom(0,3));
   %brick = new fxDTSBrick() {
		position = getWord(%pos,0)*4 SPC getword(%pos,1)*4 SPC getWord(%pos,2)*4 - 0.4;
		datablock = brickSpawnPointData;
		rotation = %rot;
		isPlanted = true;
		colorId = findclosestcolor(1 SPC 0 SPC 0 SPC 1);
		colorFxId = 0;
	   client = localClientConnection;
	};
	%brick.plant();
	%brick.setTrusted(true);
	%brick.setColliding(0);
	%brick.setRendering(0);
	%brick.setRayCasting(0);
	MissionCleanup.add(%brick);
	BrickGroup_14.add(%brick);
	$Maze::SpawnBrick[$Maze::SpawnBricks] = %brick;
   $Maze::SpawnBricks++;
	return %brick;
}
function createMazePathBrick(%pos1,%pos2) {
   %rawRotData = mazePickDataRot(scanMazeBricks((getWord(%pos1,0)+getWord(%pos2,0))/2 SPC (getWord(%pos1,1)+getWord(%pos2,1))/2 SPC (getWord(%pos1,2)+getWord(%pos2,2))/2));
   %rot = getWord(%rawRotData,1);
   %data = getWord(%rawRotData,0);
   %brick = new fxDTSBrick()
   {
		position = (getWord(%pos1,0)+getWord(%pos2,0))/2*4 SPC (getWord(%pos1,1)+getWord(%pos2,1))/2*4 SPC (getWord(%pos1,2)+getWord(%pos2,2))/2*4;
		datablock = %data;
		rotation = BrickRotationID(%rot);
		isPlanted = true;
		mazeBrick = true;
		colorId = $Maze::Color2;
		colorFxId = 0;
	   client = localClientConnection;
	};
	%brick.plant();
	%brick.setTrusted(true);
	MissionCleanup.add(%brick);
	if(!isObject(BrickGroup_14)) {
		new SimGroup(BrickGroup_14) {
			name = "Maze Generator";
			bl_id = 14;
		};
		MainBrickGroup.add(BrickGroup_14);
	}
	BrickGroup_14.add(%brick);
	$Maze::isBrick[(getWord(%pos1,0)+getWord(%pos2,0))/2 SPC (getWord(%pos1,1)+getWord(%pos2,1))/2 SPC (getWord(%pos1,2)+getWord(%pos2,2))/2] = true;
	$Maze::BrickPos[$Maze::BrickCount+1] = (getWord(%pos1,0)+getWord(%pos2,0))/2 SPC (getWord(%pos1,1)+getWord(%pos2,1))/2 SPC (getWord(%pos1,2)+getWord(%pos2,2))/2;
	return %brick;
}
function MazeNextBrick()
{
   %curr = $Maze::BrickCount;
   %Pos = getMazeBrickDirection(%curr - 2);
   %rawRotData = mazePickDataRot(scanMazeBricks(%pos));
   $Maze::RawRotData[%pos] = %rawRotData;
   %rot = getWord(%rawRotData,1);
   %data = getWord(%rawRotData,0);
   //$Maze::Brick[$Maze::BrickCount] = createMazeBrick(%pos,%data,%rot);
   $Maze::Brick[$Maze::BrickCount] = createMazeBrick(%pos,%data,%rot);
   $Maze::Brick2[$Maze::BrickPos[$Maze::BrickCount]] = $Maze::BrickCount;
   $Maze::Brick[$Maze::BrickCount+1] = createMazePathBrick($Maze::LastPos,%pos);
   if(getRandom(0,25) == 0 && $Maze::GenerateChests)
      createMazeChestBrick(%Pos);
   else if(getRandom(0,10) == 0 && $Maze::GenerateSpawns == 2)
      createMazeSpawnBrick(%Pos);
   refreshNearBricks(%pos);
   $Maze::TotalLast = %pos;
   $Maze::BrickCount+=2;
}
function refreshNearBricks(%pos)
{
   %x = getWord(%pos,0);
   %y = getWord(%pos,1);
   %z = getWord(%pos,2);
   %pos2[0] = %x + 2 SPC %y SPC %z;
   %pos2[1] = %x - 2 SPC %y SPC %z;
   %pos2[2] = %x SPC %y + 2 SPC %z;
   %pos2[3] = %x SPC %y - 2 SPC %z;
   %pos2[4] = $Maze::BrickPos[$Maze::Brick2[$Maze::LastPos] - 2];
   %pos2[5] = $Maze::BrickPos[$Maze::BrickCount-2];
   for(%i = 0; %i < 6; %i++)
      if($Maze::isBrick[%pos2[%i]])
         refreshmazebrick($Maze::Brick2[%pos2[%i]]);
}
function serverCmdMazeToggle(%client)
{
   $Maze::Enabled = !$Maze::Enabled;
   if(!%client.isSuperAdmin)
      return;
   echo("Maze "@$Maze::Enabled);
   $Maze::2d = 1;
   if(!$Maze::Color1)
      $Maze::Color1 = 1;
   if(!$Maze::Color2)
      $Maze::Color2 = 2;
   if($Maze::Enabled)
   {
      $Maze::BrickPos[0] = "0 1 0.5";
      $Maze::BrickPos[1] = "0 0 0.5";
      $Maze::BrickCount = 2;
      announce("The maze has started.");
      mazeLoop();
   }
   else
   {
      clearmazeLoop(BrickGroup_14);
      deleteVariables("$Maze::Brick*");
      deleteVariables("$Maze::RawRotData*");
      deleteVariables("$Maze::isBrick*");
      deleteVariables("$Maze::LastPos*");
      deleteVariables("$Maze::SpawnBrick*");
      $Maze::BrickCount = 2;
      $Maze::2d=0;
   }
}
function servercmdMazeTick(%client,%time)
{
   if(%time < 33)
      %time = 33;
   if(%time > 30000)
      %time = 30000;
   if(!%time || !%client.isSuperAdmin)
      return;
   announce("Maze tick time has been set to "@%time@" miliseconds");
   $Maze::TickTime = %time;
}
function servercmdMazeColor(%client,%col1, %col2)
{
   if(!%col1 || !%col2 || !%client.isSuperAdmin || %col1 > 64 || %col2 > 64)
      return;
   $Maze::Color1 = %col1;
   $Maze::Color2 = %col2;
   announce("Maze Color 1 is now "@%col1@" and Maze Color 2 is now "@%col2);
}
function servercmdMazeChests(%client)
{
   if(!%client.isSuperAdmin)
      return;
   $Maze::GenerateChests = !$Maze::GenerateChests;
   if($Maze::GenerateChests)
      announce("Maze will now generate chests.");
   else
      announce("Maze will no longer generate chests.");
}
function servercmdMazeSpawns(%client)
{
   if(!%client.isSuperAdmin)
      return;
   if($Maze::GenerateSpawns == 1)
   {
      announce("Maze will now generate Spawns Randomly.");
      $Maze::GenerateSpawns++;
   }
   else if($Maze::GenerateSpawns == 2)
   {
      announce("Maze will no longer generate spawns.");
      $Maze::GenerateSpawns = 0;
   }
   else
   {
      announce("Maze will now generate spawns at the beginning of the maze.");
      $Maze::GenerateSpawns++;
   }
}
function servercmdMazeMax(%client,%amount)
{
   if(!%client.isSuperAdmin)
      return;
   if(%amount % 2 == 1)
      %amount++;
   if(%amount <= 6)
      %amount = -1;
   $Maze::CountMax = %amount;
   if(%amount == 0)
   announce("Maze max bricks is now infinite");
   else
   announce("Maze max bricks is now "@%amount);
}
function mazeLoop()
{
   cancel($Maze::loop);
   if($Maze::Enabled != 1 || ($Maze::BrickCount > $Maze::CountMax && $Maze::CountMax != 0))
   {
      refreshNearBricks($Maze::TotalLast);
      $Maze::Brick[$Maze::BrickCount-2].setColor(0);
      announce("The maze has stopped.");
      return;
   }
   MazeNextBrick();
   $Maze::Loop = schedule($Maze::TickTime,0,mazeLoop);
}
function refreshmazebrick(%curr)
{
   %rawRotData = mazePickDataRot(scanMazeBricks($Maze::BrickPos[%curr]));
   $Maze::RawRotData[$Maze::BrickPos[%curr]] = %rawRotData;
   %rot = getWord(%rawRotData,1);
   %data = getWord(%rawRotData,0);
   replantMazeBrick($Maze::Brick[%curr],%rot,%data);
}
function getMazeBrickDirection(%curr)
{
   %pos = $Maze::BrickPos[%curr];
   $Maze::LastPos = %pos;
   %string = "";
   %x = getWord(%pos,0);
   %y = getWord(%pos,1);
   %z = getWord(%pos,2);
   if(!$Maze::isBrick[%x + 2 SPC %y SPC %z])
      %string = %string@"1";
   if(!$Maze::isBrick[%x - 2 SPC %y SPC %z])
      %string = %string@"2";
   if(!$Maze::isBrick[%x SPC %y + 2 SPC %z])
      %string = %string@"3";
   if(!$Maze::isBrick[%x SPC %y - 2 SPC %z])
      %string = %string@"4";
   if(!$Maze::isBrick[%x SPC %y SPC %z + 2] && !$Maze::2d)
      %string = %string@"5";
   if(!$Maze::isBrick[%x SPC %y SPC %z - 2] && !$Maze::2d)
      %string = %string@"6";
   if(%string $= "" || getRandom(0,2) == 0 && $Maze::BrickCount > 6)
      getMazeBrickDirection(%curr - 2);
   else
      return choosedirection(%string,%pos);
}
function chooseDirection(%string,%pos)
{
   %x = getWord(%pos,0);
   %y = getWord(%pos,1);
   %z = getWord(%pos,2);
   %poscount = 0;
   for(%i = 0; %i < 6; %i++)
      if(charamount(%string,%i+1))
      {
        %pos[%posCount] = %i+1;
        %poscount++;   
      }
   %dir = %pos[getRandom(0,%posCount-1)];
   $Maze::BrickDir[$Maze::BrickCount] = %dir;
   if(%dir == 1)
      return %x + 2 SPC %y SPC %z;
   if(%dir == 2)
      return %x - 2 SPC %y SPC %z;
   if(%dir == 3)
      return %x SPC %y + 2 SPC %z;
   if(%dir == 4)
      return %x SPC %y - 2 SPC %z;
   if(%dir == 5)
      return %x SPC %y SPC %z + 2;
   if(%dir == 6)
      return %x SPC %y SPC %z - 2;
   
}
function charamount(%string,%get)
{
	%len = strLen(%string);
	for(%i = 0; %i < %len; %i++)
	{
		%check = getSubStr(%string,%i,1);
		if(%check $= %get)
			%count++;
	}
	return %count;
}
function clearmazeLoop(%grp) {
	cancel($Maze::Clearing);
	if(!isObject(%grp) || %grp.getCount() < 1)
		return;
	%bricks = 0;
	while(%grp.getCount() > 0) {
		if(%bricks>=24)
			break;
		%grp.getObject(%grp.getCount()-1).delete();
		%bricks++;
	}
	commandToAll('centerPrint',"<just:right>\c3"@%grp.getCount() SPC "\c6bricks left.",1);
	if(!isObject(%grp) || %grp.getCount() < 1)
		return;
	$Maze::Clearing = schedule(1,0,clearmazeLoop,%grp);
}